/**
 *  input is F, T, or ?.
 */
public class TestGates
{
  public static void main(String[] args)
  {
    // Gate Tests
    char vA = 'F';
    char vB = 'T';
    char vC = '?';

    Signal s1 = new Signal(vA);
    Signal s2 = new Signal(vB);
    Signal s3 = new Signal(vC);
  
    NotGate not1 = new NotGate(s1);
    NotGate not2 = new NotGate(s2);

    AndGate g1 = new AndGate(s1, not2);
    AndGate g2 = new AndGate(s2, not1);

    System.out.println("Inputs: " + vA + vB + " output: " + g1.getOutput());
    System.out.println("Inputs: " + vA + vB + " output: " + g2.getOutput());

    AndGate g3 = new AndGate();
    System.out.println("Inputs: " + vA + vB + " output: " + g3.getOutput());


    OrGate g = new OrGate();
    g.connectA(g1);
    g.connectB(g2);
    System.out.println("Inputs: " + vA + vB + " output: " + g.getOutput());
		System.out.println();

		// Evaluating boolean algebra
		String exp1 = "TFT+*";
		RPN rpn = new RPN(exp1);
		System.out.println(exp1+" = "+rpn.evaluate());

		String exp2 = "FT+F*FF*+";
		rpn = new RPN(exp2);
		System.out.println(exp2+" = "+rpn.evaluate());
  }
}

